#include <bits/stdc++.h>
using namespace std;
const long long  mint =100000;
long double d[mint+1];
int main()
{
	long double dx,dy;
	long long w,h,r,q;
	cin>>w>>h>>r>>q;
	long long  type;
	long long xi,yi,di;
	for(int u=0;u<=w;u++) d[u]=h;
	bool ctrl=false;
	for(int g=0;g<q;g++)
	{
		cin>>type;
		if(type==1)
		{
			cin>>xi>>yi;
			for(int i=0;i<=w;i++)
			{
				dy=sqrt(r*r-(xi-i)*(xi-i));
				dx=yi-dy;
				if(dx<d[i]) d[i]=dx;
			}
		}
		if(type==2)
		{
			cin>>di;
	     	 cout<<fixed<<showpoint<<setprecision(9)<<d[di]<<endl;
		}
		
	}
	return 0;
}